Offer a run
CliqHub offers a run that only one daemon may take. The daemon races to claim it on
CliqHub with its realm token; the winner is sent Execute a run next. Losing the race is
a normal reply (claimed: false), not an error.
No credential is needed from this machine. From another host, send Authorization: Bearer with a dispatch token CliqHub signed for this daemon or a cliq_tok_… personal token of a user in the daemon’s realm; this only works once the daemon is connected to CliqHub. See Authentication.
curl --request POST \
--url http://127.0.0.1:4900/v1/offer_job \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"queue_item_id": "e1d2c3b4-a5f6-4789-8a0b-1c2d3e4f5a6b",
"kind": "run",
"payload": {
"team_id": "3f6c2a8e-6b1d-4c1e-9a57-0d2f4b8e91c4"
},
"tx_id": "tx-5d2c9a"
}
'import requests
url = "http://127.0.0.1:4900/v1/offer_job"
payload = {
"queue_item_id": "e1d2c3b4-a5f6-4789-8a0b-1c2d3e4f5a6b",
"kind": "run",
"payload": { "team_id": "3f6c2a8e-6b1d-4c1e-9a57-0d2f4b8e91c4" },
"tx_id": "tx-5d2c9a"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
queue_item_id: 'e1d2c3b4-a5f6-4789-8a0b-1c2d3e4f5a6b',
kind: 'run',
payload: {team_id: '3f6c2a8e-6b1d-4c1e-9a57-0d2f4b8e91c4'},
tx_id: 'tx-5d2c9a'
})
};
fetch('http://127.0.0.1:4900/v1/offer_job', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_PORT => "4900",
CURLOPT_URL => "http://127.0.0.1:4900/v1/offer_job",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'queue_item_id' => 'e1d2c3b4-a5f6-4789-8a0b-1c2d3e4f5a6b',
'kind' => 'run',
'payload' => [
'team_id' => '3f6c2a8e-6b1d-4c1e-9a57-0d2f4b8e91c4'
],
'tx_id' => 'tx-5d2c9a'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "http://127.0.0.1:4900/v1/offer_job"
payload := strings.NewReader("{\n \"queue_item_id\": \"e1d2c3b4-a5f6-4789-8a0b-1c2d3e4f5a6b\",\n \"kind\": \"run\",\n \"payload\": {\n \"team_id\": \"3f6c2a8e-6b1d-4c1e-9a57-0d2f4b8e91c4\"\n },\n \"tx_id\": \"tx-5d2c9a\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("http://127.0.0.1:4900/v1/offer_job")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"queue_item_id\": \"e1d2c3b4-a5f6-4789-8a0b-1c2d3e4f5a6b\",\n \"kind\": \"run\",\n \"payload\": {\n \"team_id\": \"3f6c2a8e-6b1d-4c1e-9a57-0d2f4b8e91c4\"\n },\n \"tx_id\": \"tx-5d2c9a\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("http://127.0.0.1:4900/v1/offer_job")
http = Net::HTTP.new(url.host, url.port)
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"queue_item_id\": \"e1d2c3b4-a5f6-4789-8a0b-1c2d3e4f5a6b\",\n \"kind\": \"run\",\n \"payload\": {\n \"team_id\": \"3f6c2a8e-6b1d-4c1e-9a57-0d2f4b8e91c4\"\n },\n \"tx_id\": \"tx-5d2c9a\"\n}"
response = http.request(request)
puts response.read_bodyAuthorizations
Not needed from the same machine. From another host: a dispatch JWT CliqHub signed for this daemon, or a cliq_tok_… personal token whose user is in the daemon's realm.
Body
Hub queue item to claim
1Claiming daemon id (default: this daemon)
1Job kind (logging only)
Job payload (team_id is logged)
Show child attributes
Show child attributes
Hub command id (dedup + ack)
curl --request POST \
--url http://127.0.0.1:4900/v1/offer_job \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"queue_item_id": "e1d2c3b4-a5f6-4789-8a0b-1c2d3e4f5a6b",
"kind": "run",
"payload": {
"team_id": "3f6c2a8e-6b1d-4c1e-9a57-0d2f4b8e91c4"
},
"tx_id": "tx-5d2c9a"
}
'import requests
url = "http://127.0.0.1:4900/v1/offer_job"
payload = {
"queue_item_id": "e1d2c3b4-a5f6-4789-8a0b-1c2d3e4f5a6b",
"kind": "run",
"payload": { "team_id": "3f6c2a8e-6b1d-4c1e-9a57-0d2f4b8e91c4" },
"tx_id": "tx-5d2c9a"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
queue_item_id: 'e1d2c3b4-a5f6-4789-8a0b-1c2d3e4f5a6b',
kind: 'run',
payload: {team_id: '3f6c2a8e-6b1d-4c1e-9a57-0d2f4b8e91c4'},
tx_id: 'tx-5d2c9a'
})
};
fetch('http://127.0.0.1:4900/v1/offer_job', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_PORT => "4900",
CURLOPT_URL => "http://127.0.0.1:4900/v1/offer_job",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'queue_item_id' => 'e1d2c3b4-a5f6-4789-8a0b-1c2d3e4f5a6b',
'kind' => 'run',
'payload' => [
'team_id' => '3f6c2a8e-6b1d-4c1e-9a57-0d2f4b8e91c4'
],
'tx_id' => 'tx-5d2c9a'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "http://127.0.0.1:4900/v1/offer_job"
payload := strings.NewReader("{\n \"queue_item_id\": \"e1d2c3b4-a5f6-4789-8a0b-1c2d3e4f5a6b\",\n \"kind\": \"run\",\n \"payload\": {\n \"team_id\": \"3f6c2a8e-6b1d-4c1e-9a57-0d2f4b8e91c4\"\n },\n \"tx_id\": \"tx-5d2c9a\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("http://127.0.0.1:4900/v1/offer_job")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"queue_item_id\": \"e1d2c3b4-a5f6-4789-8a0b-1c2d3e4f5a6b\",\n \"kind\": \"run\",\n \"payload\": {\n \"team_id\": \"3f6c2a8e-6b1d-4c1e-9a57-0d2f4b8e91c4\"\n },\n \"tx_id\": \"tx-5d2c9a\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("http://127.0.0.1:4900/v1/offer_job")
http = Net::HTTP.new(url.host, url.port)
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"queue_item_id\": \"e1d2c3b4-a5f6-4789-8a0b-1c2d3e4f5a6b\",\n \"kind\": \"run\",\n \"payload\": {\n \"team_id\": \"3f6c2a8e-6b1d-4c1e-9a57-0d2f4b8e91c4\"\n },\n \"tx_id\": \"tx-5d2c9a\"\n}"
response = http.request(request)
puts response.read_body